#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include "tree.h"
#include "optimise.h"

int done;

void end(int sig)
{
	done = 1;
}

int main(int argc, char **argv)
{
    int i;

    /* set the timer */
    done = 0;
    signal(SIGALRM, end);
    alarm(atoi(argv[1])-10);
	
	/* load document */
	load(stdin);
	
	
	if(done)
	{
		out(root);
		cleanup(root);
		return 0;
	}
	
	/* optimizations */
	opt_white(root);
	if(done)
	{
		out(root);
		cleanup(root);
		return 0;
	}
	
		optimise1();

		i=1;
		while (i!=0 && !done)
		{
			i=optimise2();
		}
	
	/* output */
	out(root);		/* normal output */
		
	/* cleanup tree */
	cleanup(root);
	
	/* quit */
	return 0;
}
