/***************************************************************************
                          optimise.c  -  description
                             -------------------
    begin                : Sat Jul 28 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "tree.h"
#include "optimise.h"

/* helper functions */
void attr2space(attribs *a);	/* convert attributes to "space attributes" */
int is_white(char val);			/* return 1 if val is whitespace */


int optimise2(void)
{
 node *place=root,*t;
 int i,j,result=0,k;
 int doneflag=0;
 char *tmp;
 place->scratch=0;

 while (!(place==root && place->scratch>=root->child_count))
 {
  while (place->scratch < place->child_count)  /* search 4 bottom */
  {
   if (place->children[place->scratch]->is_tag == 0)
   {
     place->scratch ++;
   } else{
     place=place->children[place->scratch];
     place->scratch = 0;
   }
  }
   /* should be at a relatively lowest level... this is the node level
      optimisation */
   /*--- elimnate dummy tags!---*/
   if (place==root && place->scratch>=root->child_count) doneflag=2;

 if (doneflag!=1)
 {  /*---- do node opt!---*/
    /* combine adjacent identical tags--- ignore text */
    for (i=0;i<place->child_count-1;i++)
    {
      if (place->children[i]->tag==place->children[i+1]->tag  && place->children[i]->is_tag ==1 && place->children[i+1]->is_tag == 1)
      {
        result++;
        memmove(&place->children[i]->children[place->children[i]->child_count],
                &place->children[i+1]->children[0], place->children[i+1]->child_count*sizeof (struct treenode *));
        for (j=0;j<place->children[i+1]->child_count;j++)
        {
         place->children[i+1]->children[j]->parent=place->children[i];
         place->children[i+1]->children[j]=NULL;
        }
        place->children[i]->child_count+=place->children[i+1]->child_count;
        place->children[i+1]->child_count=0;
        t=place->children[i+1];
        memmove(&place->children[i+1],&place->children[i+2],(place->child_count-i-1)*sizeof(struct treenode *));
        place->child_count--;
        cleanup(t);
      }  else if ( place->children[i]->tag==place->children[i+1]->tag  && place->children[i]->is_tag ==0 && place->children[i+1]->is_tag == 0)
      	{  /* combine text */
      	   k=strlen(place->children[i]->text)+strlen(place->children[i+1]->text);
      	   tmp=malloc((k+2)*sizeof (char *));
      	   strcpy(tmp,place->children[i]->text);
      	   strcat(tmp,place->children[i+1]->text);
      	   free(place->children[i]->text);
      	   place->children[i]->text=tmp;
      	   cleanup (place->children[i+1]);
      	   memmove(&place->children[i+1],&place->children[i+2],(place->child_count-i-1)*sizeof(struct treenode *));
      	   place->child_count--;
      	
      	
      	
      	}
    }
        for (i=0;i<place->child_count-1;i++)
    {
      if (place->children[i]->tag >=TAG_COLOR_RED && place->children[i]->tag <=TAG_COLOR_WHITE)
      {
       for (j=i+1;j<place->child_count;j++)
       {
           if (place->children[j]->tag >=TAG_COLOR_RED && place->children[j]->tag <=TAG_COLOR_WHITE)
           {
             if (place->children[j]->tag==place->children[i]->tag)
             {/* have match.... move down*/
               memmove(&place->children[i]->children[place->children[i]->child_count],
                       &place->children[i+1],(j-i-1)*sizeof(struct treenode *));
               for (k=i+1;k<j;k++)
               {
                  place->children[k]->parent=place->children[i];
               }
               memmove(&place->children[i+1],&place->children[j],(place->child_count-j)*sizeof(struct treenode *));
               place->children[i]->child_count+=(j-i-1);
               place->child_count-=(j-i-1);


             }
           } else {
             break;
           }
       }
      }
    }
          for (i=0;i<place->child_count-1;i++)
    {
      if (place->children[i]->tag >=TAG_SIZE_0 && place->children[i]->tag <=TAG_SIZE_9)
      {
       for (j=i+1;j<place->child_count;j++)
       {
           if (place->children[j]->tag >=TAG_SIZE_0 && place->children[j]->tag <=TAG_SIZE_9)
           {
             if (place->children[j]->tag==place->children[i]->tag)
             {/* have match.... move down*/
               memmove(&place->children[i]->children[place->children[i]->child_count],
                       &place->children[i+1],(j-i-1)*sizeof(struct treenode *));
               for (k=i+1;k<j;k++)
               {
                  place->children[k]->parent=place->children[i];
               }
               memmove(&place->children[i+1],&place->children[j],(place->child_count-j)*sizeof(struct treenode *));
               place->children[i]->child_count+=(j-i-1);
               place->child_count-=(j-i-1);


             }
           } else {
             break;
           }
       }
      }
    }
    if (!doneflag)
    {
    place=place->parent;
    place->scratch++;
    } else {
      doneflag=0;
     }



 } else {
 	doneflag=0;
 	
 }

 }
 return result;
}
void optimise1(void)
{
 node *place=root,*t;
 int i,j,k;
 char *tmp;
 int doneflag=0;
 place->scratch=0;

 while (!(place==root && place->scratch>=root->child_count))
 {
  while (place->scratch < place->child_count)  /* search 4 bottom */
  {
   if (place->children[place->scratch]->is_tag == 0)
   {
     place->scratch ++;
   } else{
     place=place->children[place->scratch];
     place->scratch = 0;
   }
  }
   /* should be at a relatively lowest level... this is the node level
      optimisation */
   /*--- elimnate dummy tags!---*/
   if (place==root && place->scratch>=root->child_count) doneflag=2;
   if (doneflag==0 && place->tag==TAG_DUMMY)
   {/* eliminate tag and raise children*/
     switch (place->child_count)
     {
       case 0:
            /*wasted tag*/
            if (place->parent->scratch==place->parent->child_count-1)
            { /* last one above! */
              place->parent->children[ --(place->parent->child_count) ]==NULL;
            } else {
              memmove(&place->parent->children[place->parent->scratch],
            		&place->parent->children[place->parent->scratch+1],
            		(place->parent->child_count-1-place->parent->scratch)*sizeof(struct treenode *));
              place->parent->child_count--;
              place->parent->children[place->parent->child_count]=NULL;
            }
            t=place->parent;
            cleanup(place);
            place=t;
            doneflag=1;
       		break;
       case 1:
            /*just shift up*/
            place->parent->children[place->parent->scratch]=place->children[0];
            place->children[0]->parent=place->parent;
            place->children[0]=NULL;
            t=place->parent;
            t->child_count+=place->child_count-1;
            place->child_count=0;

            doneflag=1;
            cleanup(place);
            place=t;
            break;
       default:
            /*got to shift crap!*/
            if (place->parent->scratch==place->parent->child_count-1)
            { /*last one*/
              memmove(&place->parent->children[place->parent->scratch],
                      &place->children[0],place->child_count * sizeof(struct treenode *));
              for (i=0;i<place->child_count;i++)
              {
                place->children[i]->parent=place->parent;
                place->children[i]=NULL;
              }
              t=place->parent;
              t->child_count+=place->child_count-1;
              place->child_count=0;
              cleanup(place);
              place=t;
              doneflag=1;
            } else {
              memmove (&place->parent->children[place->parent->scratch+place->child_count-1],
                       &place->parent->children[place->parent->scratch+1], (place->child_count-1) * sizeof(struct treenode *));
              memmove (&place->parent->children[place->parent->scratch],
                       &place->children[0], (place->child_count) * sizeof(struct treenode *));
              t=place->parent;
              t->child_count+=place->child_count;
              for (i=0;i<place->child_count;i++)
              {
                place->children[i]->parent=place->parent;
                place->children[i]=NULL;
              }
              cleanup (place);
              place=t;
              doneflag=1;


            }
            break;
      }
   }
   if (!doneflag && place->child_count==0)
   {
     t=place->parent;
     if (t->scratch==t->child_count-1)
     {
      t->children[t->scratch]=NULL;
      t->child_count--;
      cleanup(place);
      doneflag=1;
      place=t;
     } else {
      memmove(&t->children[t->scratch],&t->children[t->scratch+1],(t->child_count-t->scratch-1)*sizeof(struct treenode *));
      t->child_count--;
      t->children[t->child_count]=NULL;
      cleanup(place);
      doneflag=1;
      place=t;
     }

   }
   /*start with color/size nesting....*/



 if (doneflag!=1)
 {  /*---- do node opt!---*/
    /* combine adjacent identical tags--- ignore text */
    for (i=0;i<place->child_count-1;i++)
    {
      if (place->children[i]->tag==place->children[i+1]->tag  && place->children[i]->is_tag ==1 && place->children[i+1]->is_tag == 1)
      {
        memmove(&place->children[i]->children[place->children[i]->child_count],
                &place->children[i+1]->children[0], place->children[i+1]->child_count*sizeof (struct treenode *));
        for (j=0;j<place->children[i+1]->child_count;j++)
        {
         place->children[i+1]->children[j]->parent=place->children[i];
         place->children[i+1]->children[j]=NULL;
        }
        place->children[i]->child_count+=place->children[i+1]->child_count;
        place->children[i+1]->child_count=0;
        t=place->children[i+1];
        memmove(&place->children[i+1],&place->children[i+2],(place->child_count-i-1)*sizeof(struct treenode *));
        place->child_count--;
        cleanup(t);
      }  else if ( place->children[i]->tag==place->children[i+1]->tag  && place->children[i]->is_tag ==0 && place->children[i+1]->is_tag == 0)
      	{  /* combine text */
      	   k=strlen(place->children[i]->text)+strlen(place->children[i+1]->text);
      	   tmp=malloc((k+2)*sizeof (char *));
      	   strcpy(tmp,place->children[i]->text);
      	   strcat(tmp,place->children[i+1]->text);
      	   free(place->children[i]->text);
      	   place->children[i]->text=tmp;
      	   cleanup (place->children[i+1]);
      	   memmove(&place->children[i+1],&place->children[i+2],(place->child_count-i-1)*sizeof(struct treenode *));
      	   place->child_count--;
      	
      	
      	
      	}
    }


    for (i=0;i<place->child_count-1;i++)
    {
      if (place->children[i]->tag >=TAG_COLOR_RED && place->children[i]->tag <=TAG_COLOR_WHITE)
      {
       for (j=i+1;j<place->child_count;j++)
       {
           if (place->children[j]->tag >=TAG_COLOR_RED && place->children[j]->tag <=TAG_COLOR_WHITE)
           {
             if (place->children[j]->tag==place->children[i]->tag)
             {/* have match.... move down*/
               memmove(&place->children[i]->children[place->children[i]->child_count],
                       &place->children[i+1],(j-i-1)*sizeof(struct treenode *));
               for (k=i+1;k<j;k++)
               {
                  place->children[k]->parent=place->children[i];
               }
               memmove(&place->children[i+1],&place->children[j],(place->child_count-j)*sizeof(struct treenode *));
               place->children[i]->child_count+=(j-i-1);
               place->child_count-=(j-i-1);


             }
           } else {
             break;
           }
       }
      }
    }

        for (i=0;i<place->child_count-1;i++)
    {
      if (place->children[i]->tag >=TAG_SIZE_0 && place->children[i]->tag <=TAG_SIZE_9)
      {
       for (j=i+1;j<place->child_count;j++)
       {
           if (place->children[j]->tag >=TAG_SIZE_0 && place->children[j]->tag <=TAG_SIZE_9)
           {
             if (place->children[j]->tag==place->children[i]->tag)						
             {/* have match.... move down*/
               memmove(&place->children[i]->children[place->children[i]->child_count],
                       &place->children[i+1],(j-i-1)*sizeof(struct treenode *));
               for (k=i+1;k<j;k++)
               {
                  place->children[k]->parent=place->children[i];
               }
               memmove(&place->children[i+1],&place->children[j],(place->child_count-j)*sizeof(struct treenode *));
               place->children[i]->child_count+=(j-i-1);
               place->child_count-=(j-i-1);


             }
           } else {
             break;
           }
       }
      }
    }


    if (!doneflag)
    {
    place=place->parent;
    place->scratch++;
    } else {
      doneflag=0;
     }

 } else {
 	doneflag=0;
 	
 }



 } /* end the opt loop*/

}


int scan_text(node *top)
{
	int ret = 0;
	int child;
	static node *t1 = NULL, *t2 = NULL;
	
	if(!top->is_tag)
	{
		if(!t1) t1 = top;
		else t2 = top;
		
		top->scratch = top->parent->scratch;
		
		if(t1 && t2)
		{
			/* if the attributes are exactly the same */
			if(!memcmp(&t1->attr, &t2->attr, sizeof(attribs)))
			{
				/* move the text */
					if(t1->scratch != t1->parent->child_count - 1)
						memmove(&t1->parent->children[t1->scratch+1], &t1->parent->children[t1->scratch+2],
						sizeof(node *) * (t1->parent->child_count - t1->scratch - 1));
				t1->parent->children[t1->scratch+1] = t2;
				t2->parent = t1->parent;
				t1->parent->child_count += 1;
				t1 = t2;
				return 1;
			}
			else{
				if(!t1->attr.bold && t2->attr.bold)
				{
					node *tmp;
					
					/* create placeholder tag */
					if(t1->scratch != t1->parent->child_count - 1)
						memmove(&t1->parent->children[t1->scratch+1], &t1->parent->children[t1->scratch+2],
						sizeof(node *) * (t1->parent->child_count - t1->scratch - 1));
					t1->parent->children[t1->scratch+1] = (node *) malloc(sizeof(node));
					tmp = t1->parent->children[t1->scratch+1];
					t1->parent->child_count += 1;
					
					tmp->is_tag = 1;
					tmp->text   = NULL;
					tmp->tag    = TAG_BOLD;
					memcpy(&tmp->attr, &t1->parent->attr, sizeof(attribs));
					tmp->attr.bold = 1;
					tmp->child_count = 0;
					tmp->parent = t1->parent;
					return 1;
				}
				if(!t1->attr.italic && t2->attr.italic)
				{
					node *tmp;
					
					/* create placeholder tag */
					if(t1->scratch != t1->parent->child_count - 1)
						memmove(&t1->parent->children[t1->scratch+1], &t1->parent->children[t1->scratch+2],
						sizeof(node *) * (t1->parent->child_count - t1->scratch - 1));
					t1->parent->children[t1->scratch+1] = (node *) malloc(sizeof(node));
					tmp = t1->parent->children[t1->scratch+1];
					t1->parent->child_count += 1;
					
					tmp->is_tag = 1;
					tmp->text   = NULL;
					tmp->tag    = TAG_ITALIC;
					memcpy(&tmp->attr, &t1->parent->attr, sizeof(attribs));
					tmp->attr.italic = 1;
					tmp->child_count = 0;
					tmp->parent = t1->parent;
					return 1;
				}
				if(t1->attr.emphasis != t2->attr.emphasis)
				{
					node *tmp;
					
					/* create placeholder tag */
					if(t1->scratch != t1->parent->child_count - 1)
						memmove(&t1->parent->children[t1->scratch+1], &t1->parent->children[t1->scratch+2],
						sizeof(node *) * (t1->parent->child_count - t1->scratch - 1));
					t1->parent->children[t1->scratch+1] = (node *) malloc(sizeof(node));
					tmp = t1->parent->children[t1->scratch+1];
					t1->parent->child_count += 1;
					
					tmp->is_tag = 1;
					tmp->text   = NULL;
					tmp->tag    = TAG_EMPHASIS;
					memcpy(&tmp->attr, &t1->parent->attr, sizeof(attribs));
					tmp->attr.emphasis = !tmp->attr.emphasis;
					tmp->child_count = 0;
					tmp->parent = t1->parent;
					return 1;
				}
				if(!t1->attr.strong && t2->attr.strong)
				{
					node *tmp;
					
					/* create placeholder tag */
					if(t1->scratch != t1->parent->child_count - 1)
						memmove(&t1->parent->children[t1->scratch+1], &t1->parent->children[t1->scratch+2],
						sizeof(node *) * (t1->parent->child_count - t1->scratch - 1));
					t1->parent->children[t1->scratch+1] = (node *) malloc(sizeof(node));
					tmp = t1->parent->children[t1->scratch+1];
					t1->parent->child_count += 1;
					
					tmp->is_tag = 1;
					tmp->text   = NULL;
					tmp->tag    = TAG_STRONG;
					memcpy(&tmp->attr, &t1->parent->attr, sizeof(attribs));
					tmp->attr.strong = 1;
					tmp->child_count = 0;
					tmp->parent = t1->parent;
					return 1;
				}
				if(!t1->attr.typewriter && t2->attr.typewriter)
				{
					node *tmp;
					
					/* create placeholder tag */
					if(t1->scratch != t1->parent->child_count - 1)
						memmove(&t1->parent->children[t1->scratch+1], &t1->parent->children[t1->scratch+2],
						sizeof(node *) * (t1->parent->child_count - t1->scratch - 1));
					t1->parent->children[t1->scratch+1] = (node *) malloc(sizeof(node));
					tmp = t1->parent->children[t1->scratch+1];
					t1->parent->child_count += 1;
					
					tmp->is_tag = 1;
					tmp->text   = NULL;
					tmp->tag    = TAG_TYPEWRITER;
					memcpy(&tmp->attr, &t1->parent->attr, sizeof(attribs));
					tmp->attr.typewriter = 1;
					tmp->child_count = 0;
					tmp->parent = t1->parent;
					return 1;
				}
				if(t1->attr.underline < t2->attr.underline)
				{
					node *tmp;
					
					/* create placeholder tag */			
					if(t1->scratch != t1->parent->child_count - 1)
						memmove(&t1->parent->children[t1->scratch+1], &t1->parent->children[t1->scratch+2],
						sizeof(node *) * (t1->parent->child_count - t1->scratch - 1));
					t1->parent->children[t1->scratch+1] = (node *) malloc(sizeof(node));
					tmp = t1->parent->children[t1->scratch+1];
					t1->parent->child_count += 1;
					
					tmp->is_tag = 1;
					tmp->text   = NULL;
					tmp->tag    = TAG_UNDERLINE;
					memcpy(&tmp->attr, &t1->parent->attr, sizeof(attribs));
					tmp->attr.underline = 1;
					tmp->child_count = 0;
					tmp->parent = t1->parent;
					return 1;
				}
			}
		}
	}
	else
	{
		for(child = 0; child < top->child_count; child ++)
			if(!ret) ret = scan_text(top->children[child]);
			else scan_text(top->children[child]);
	}
	return ret;
}

/*node *copy_tree(node *from)
{
	int child;
	node *ret;
	
	ret = (treenode *) malloc(sizeof(treenode));
	
	ret->is_tag      = from->is_tag;
	ret->tag         = from->tag;
	ret->child_count = from->child_count;
	memcpy(&ret->attr, &from->attr, sizeof(attribs));
	ret->text
	ret->
} */

/* remove any and all unneccesary whitespace */
void opt_white(node *a)
{
	/* space attributes, for comparison */
	static attribs a1 =
	{ /* the first time through, set impossible flags, so required leading text isn't dropped */
		1, 0, 0, 0, 0, 0, 0, COLOR_DEFAULT
	};
	attribs a2;
	
	int    child;
	
	/* calculate space attributes */
	memcpy(&a2, &a->attr, sizeof(attribs));
	attr2space(&a2);

	/* do not edit text if tag node */	
	/* do not edit whitespace at all if typewriter is on */
	if(!a->is_tag && !a2.typewriter)
	{
		int pos = 0, pos2;
		
		/* is stuff compatible enough that i can delete the node if it's all whitespace */
		int compat;
		char *text = a->text;
		
		/* are we allowed to remove leading whitespace */
		/* if not don't look at first byte.  if it was whitespace, it stays. */
		/* if not, didn't matter anyway */
		compat = !memcmp(&a1, &a2, sizeof(attribs));
		
		while(1)
		{
			/* find whitespace to reduce */
			while(text[pos] && !is_white(text[pos]))
				pos += 1;
			if(!text[pos])	/* no more whitespace */
				break;
				
			pos2 = pos; /* whitespace end is after whitespace start */
			while(is_white(text[pos2])) pos2 += 1;
			pos2 -= 1;
			
			if(pos2 != pos)
			{
				/* truncate whitespace */
				memmove(&text[pos], &text[pos2], sizeof(char) * (strlen(text) - pos2 + 1));
			}
			pos += 1;
		}
		
		/* if i'm allowed to destroy the entire thing, and the whole was whitespace */
		if(compat && strlen(text) == 1 && is_white(text[0]))
		{
			free(text);		/* duh */
			a->text = NULL; /* set flag for parent to delete this, otherwise interferes with loops */
		}
	}
	
	/* these flags matter (ie. is text node) */
	/* move flags into a1 for use by next node */
	if(!a->is_tag)
	{
		memcpy(&a1, &a2, sizeof(attribs));
		if(a->text && !is_white(a->text[strlen(a->text) - 1])) a1.bold = 1;
	}

	/* optimize next pieces of text */	
	for(child = 0; child < a->child_count; child ++)
		opt_white(a->children[child]);
	
	/* find and remove text subnodes with no text */
	child = 0;
	while(child < a->child_count)
	{
		if(a->children[child]->is_tag || a->children[child]->text)
		{
			child += 1;
			continue;
		}
		
		/* we've found one that has no text */
		free(a->children[child]);
        memmove(&a->children[child],
            		&a->children[child + 1],
            		(a->child_count - 1 - child)*sizeof(struct treenode *));
		a->child_count -= 1;
	}
}

/* convert attributes to "space attributes" */
void attr2space(attribs *a)
{
	/* these are irrelevant for whitespace */
	a->bold     = 0;
	a->emphasis = 0;
	a->italic   = 0;
	a->strong   = 0;
	
	/* if there's no underline, color is irrelevant */
	if(!a->underline) a->color = COLOR_WHITE;
}

int is_white(char val)
{
	if(val == 0x20 || val == 0x0D || val == 0x0A || val == 0x09) return 1;
	else return 0;
}
